package net.jaekl.frank;

import java.util.HashMap;

import net.jaekl.qd.http.HttpServletRequestMock;

import org.junit.Assert;
import org.junit.Test;

public class ViewScheduleTest {
	
	private HashMap<String, String[]> makeParamMap() {
		String[] routeNos = { "127" };
		String[] alphas = { "abcdefg" };
		String[] kanas = { "あいうえお" };

		HashMap<String, String[]> paramMap = new HashMap<String, String[]>();
		paramMap.put("routeNo", routeNos);
		paramMap.put("alpha", alphas);
		paramMap.put("kana", kanas);
		
		return paramMap;
	}
	
	@Test
	public void testGetParamInt() {
		HashMap<String, String[]> paramMap = makeParamMap();
		HttpServletRequestMock reqMock = new HttpServletRequestMock(paramMap);
		ViewSchedule vs = new ViewSchedule();

		// Try to get a parameter that is an integer, and is there
		int value = vs.getParamInt(reqMock, "routeNo");
		Assert.assertEquals(127, value);
		
		// Try to get a parameter that is not an integer
		value = vs.getParamInt(reqMock, "alpha");
		Assert.assertEquals(0, value);
		
		// Try to get a parameter that is not alphanumeric
		value = vs.getParamInt(reqMock, "kana");
		Assert.assertEquals(0, value);
		
		// Try to get a parameter that is not present 
		value = vs.getParamInt(reqMock, "notPresent");
		Assert.assertEquals(0, value);
	}

	@Test
	public void testGetParamString() {
		HashMap<String, String[]> paramMap = makeParamMap();
		HttpServletRequestMock reqMock = new HttpServletRequestMock(paramMap);
		ViewSchedule vs = new ViewSchedule();

		// Try to get a parameter that is an integer, and is there
		String value = vs.getParamString(reqMock, "routeNo");
		Assert.assertEquals("127", value);
		
		// Try to get a parameter that is not an integer
		value = vs.getParamString(reqMock, "alpha");
		Assert.assertEquals("abcdefg", value);
		
		// Try to get a parameter that is not alphanumeric
		value = vs.getParamString(reqMock, "kana");
		Assert.assertEquals("あいうえお", value);
		
		// Try to get a parameter that is not present 
		value = vs.getParamString(reqMock, "notPresent");
		Assert.assertEquals(null, value);
	}
}
